//=============================================================================
// o̓NX(GateIO)p̃Oobt@NX
//=============================================================================
#include	<windows.h>
#include	<commctrl.h>
#include	<iostream>
#include	<vector>
using namespace std;
#include	"common.h"
#include	"RingBuf.h"




//--------------------------------------------------------------------------
// RXgN^
//--------------------------------------------------------------------------
RINGBUF::RINGBUF()
{
	GateP = MakeNewStr(GATEBUFF_MAX,ST_GATE_MAX);		// GA쐬
	GateC = GATEBUFF_MAX-1;					// OJE^
	//------------------------------------------------------
	RingP = MakeNewStr(RINGBUFF_MAX,ST_RING_MAX);		// GA쐬
	RingC = RINGBUFF_MAX-1;					// OJE^
}

//--------------------------------------------------------------------------
// fXgN^
// svɂȂGAJ
//--------------------------------------------------------------------------
RINGBUF::~RINGBUF()
{
	int a=0;
	for(a=0;a<GATEBUFF_MAX;a++){
		delete[] GateP[a].data;
	}
	delete[] GateP;
	for(a=0;a<RINGBUFF_MAX;a++){
		delete[] RingP[a].data;
	}
	delete[] RingP;
}

//--------------------------------------------------------------------------
// 
// IuWFNg̐Ajɂ͎Ԃ
//--------------------------------------------------------------------------
void RINGBUF::RINGBUF_Shyokika()
{
	int a=0;
	for(a=0;a<GATEBUFF_MAX;a++){
		*GateP[a].data = '\0';
	}
	for(a=0;a<RINGBUFF_MAX;a++){
		*RingP[a].data = '\0';
	}
	GateC = GATEBUFF_MAX-1;					// OJE^
	RingC = RINGBUFF_MAX-1;					// OJE^
}


//--------------------------------------------------------------------------
// \[Xt@CύX̏
//--------------------------------------------------------------------------
void RINGBUF::RINGBUF_SrcChg(int lang)
{
	ReadLang = lang;
}


//--------------------------------------------------------------------------
// ͑Oobt@Ƀf[^Zbg
//--------------------------------------------------------------------------
void RINGBUF::SetGateBuff(char *moji)
{
	GateC = (GateC+1)>=GATEBUFF_MAX ? 0 : GateC+1 ;
	CopyStr(&GateP[GateC], moji);
}


//--------------------------------------------------------------------------
// f[^pOobt@Ƀf[^Zbg
//--------------------------------------------------------------------------
void RINGBUF::SetRingBuff(char *moji)
{
	RingC = (RingC+1)>=RINGBUFF_MAX ? 0 : RingC+1 ;
	CopyStr(&RingP[RingC], moji);
}


//--------------------------------------------------------------------------
// ͑Oobt@̓e݂鎞Ɏg
//--------------------------------------------------------------------------
char *RINGBUF::GetGateBuff(int a)
{
	int ad = (GateC-a)>=0 ? (GateC-a) : (GATEBUFF_MAX+GateC-a);
	return GateP[ad].data;
}

//--------------------------------------------------------------------------
// f[^pOobt@̓e鎞Ɏg
//--------------------------------------------------------------------------
char *RINGBUF::GetRingBuff(int a)
{
	int ad = (RingC-a)>=0 ? (RingC-a) : (RINGBUFF_MAX+RingC-a);
	return RingP[ad].data;
}


//--------------------------------------------------------------------------
// w肵O̕𓾂
//--------------------------------------------------------------------------
char *RINGBUF::BeforeString(int kazu)
{
	if(ReadLang & MASK_BIT_VB){
		return GetRingBuff(kazu);
	}

	if(kazu == 0){
		return GetRingBuff(0);
	}

	int ad = RingC;
	char *moji = NULL;
	while(1){
		ad = (ad-1)>=0 ? (ad-1) : (RINGBUFF_MAX-1);	// ÕAhXɈړ
		moji = RingP[ad].data;
		if( *moji==' ' || *moji=='\t' || *moji=='\n' ){	// 󔒓͍폜
			continue;
		}
		kazu--;
		if( kazu <= 0 )
			break;
	}
	return RingP[ad].data;
}


//--------------------------------------------------------------------------
// ʂ̑ÕIuWFNg擾 ObjName[]
//--------------------------------------------------------------------------
char *RINGBUF::GetBeforeKakko(int *mae)
{
	int kakko = 1;

	for(int a=*mae;a<RINGBUFF_MAX;a++){
		char *moji = BeforeString(a);

		if(*moji == '['){
			kakko--;
		}else if(*moji == ']'){
			kakko++;
		}

		if(kakko <= 0){
			char *beforeP = BeforeString(a+1);
			if(*beforeP == ']'){
				continue;
			}
			if( kugirimoji(*beforeP) ){		// ؂蕶Ȃ
				return "";
			}
			*mae = a+1;
			return beforeP;
		}
	}

	return "";						// obt@ŌłȂ
}

//--------------------------------------------------------------------------
// ۊʂ̑O̕擾 MyFunc()
//--------------------------------------------------------------------------
char *RINGBUF::GetBeforeMarukakko(int *mae)
{
	int maru = 1;

	for(int a=*mae;a<RINGBUFF_MAX;a++){
		char *moji = BeforeString(a);

		if(*moji == '('){
			maru--;
		}else if(*moji == ')'){
			maru++;
		}

		if(maru <= 0){
			char *beforeP = BeforeString(a+1);
			if( kugirimoji(*beforeP) ){		// ؂蕶Ȃ
				return "";
			}
			*mae = a+1;
			return beforeP;
		}
	}

	return "";						// obt@ŌłȂ
}

//--------------------------------------------------------------------------
// ۊʂ̏ꍇ̃IuWFNg擾 (*ObjName[]).Func
// int mae   : n߂ʒu
// int use   : ֐ƂĎgpꍇA(ObjName[])();
// int *SetP : ֐|C^ƂĐ錾Ăꍇ 1
//--------------------------------------------------------------------------
char *RINGBUF::GetObjInMaruKakko(int *mae, int use, int *SetP)
{
	char *ObjName = BeforeString(*mae);

	*SetP = 0;						// 

	if(*ObjName == ']'){
		ObjName = GetBeforeKakko(mae);
		if( ! ObjName ){
			return "";
		}
	}
	if( kugirimoji(*ObjName) ){				// ؂蕶Ȃ
		return "";
	}
	*mae = *mae+1;

	int p_flg = 0;
	for(int a=*mae;a<RINGBUFF_MAX;a++){
		char *ck_p = BeforeString(a);
		*mae = a+1;
		if( *ck_p == '*' ){
			p_flg = 1;
			continue;
		}else if( *ck_p == '(' ){
			break;
		}else if( ! strcmp(ck_p, "const") ){
			continue;
		}else{
			return "";
		}
	}
	if( p_flg ){
		*SetP = 1;
		return ObjName;
	}else if( use ){
		return ObjName;
	}
	return "";
}


