#ifndef	GATEIO	///////////////////////////////
#define	GATEIO	1


//--------------------------------------------------------------------------
// #oƂ̃Xe[^X
//--------------------------------------------------------------------------
enum{
	CM_NON = 0,
	CM_SHARP,
	CM_DEFINE,				// #define `̓o^
	CM_DEFINE_MAKURO,			// #define }N̈o^
	CM_DEFINE_DATA,				// #define `eo^
	CM_DEFINE_ERR,				// #define `dčsĂꍇ
	CM_UNDEF,
	CM_IFDEF,
	CM_IFNDEF,
	CM_ELSE,
	CM_IF,
	CM_ELIF,
	CM_INCLUDE,				// #include
	CM_IMPORT,				// #import
	CM_PRAGMA,				// #pragma
	CM_INTERRUPT,				// 荞
	CM_SHARP_WAIT,				// # ͌̍sRgƂĈ
	CM_EP_CONF,				// Eptree̐ݒ
	CM_EP_INTERRUPT
};

//--------------------------------------------------------------------------
// EPTREE̒`̓ǂݍ݂̃[h
//--------------------------------------------------------------------------
enum{
	EP_CONF_RESERV = 0,			// 0,\
	EP_CONF_CLASS,				// 1,NX`
	EP_CONF_TYPE				// 2,^`
};


//--------------------------------------------------------------------------
// Rg̏
//--------------------------------------------------------------------------
enum{
	COMMENT_NON = 0,			// ʏ̏
	//---- delphi ----
	COMMENT_KAKKO,				// {ɂRgԁA"{"  "(*"͓̂ƂĈ
	COMMENT_KAKKO_WAIT,			// (*)ɂRgɑΉ
	COMMENT_KAKKO_WAIT2,			// (*)ɂRgɑΉ
	//------ vb ------
	COMMENT_KANMA,				// 'ɂRg
	//----------------
	COMMENT_THRA,				// _uXbVɂRg
	COMMENT_THRA_WAIT,			// 
	COMMENT_ASTA,				// XbVAX^ɂRg
	COMMENT_MOJI,				// "ɂvO̕ (C,C++,JAVA,VB)
						// 'ɂvO̕ (Delphi)
	COMMENT_ICHIMOJI,			//
	COMMENT_ICHIMOJI_WAIT,			//
	COMMENT_ICHIMOJI_EN,			//
	COMMENT_ASTA_WAIT,			// "/*/ Rg"ɑΉ
	COMMENT_ASTA_WAIT2,			// "/*/ Rg"ɑΉ
	COMMENT_ASM				// AZũRg";"
};


enum{
	STR_CODE_NON = 0,
	STR_CODE_SHIFT,
	STR_CODE_EUC,
	STR_CODE_UNICODE
};


#define	ST_MUKO			0
#define	ST_YUKO			1

#define	ST_IFDEF		0
#define	ST_IF			1


struct IF_OR_IFDEF {
	int	type;				// ^Cv(if_or_ifdef)
	int	out;				// LɂȂǂ(LɂȂƂ΂P)
};


//--------------------------------------------------------------------------
//--------------------------------------------------------------------------
class GateIO : public RINGBUF
{
public:
	GateIO(int);				// RXgN^
	virtual ~GateIO();			// fXgN^
	char *SetStrCode(char *);		// R[hZbg
	int  read_Tango(char **, int);
	char *read_TangoShiftJIS(char *);
	char *read_TangoUniCode(char *);
	char *read_TangoEUC(char *);
	int  CommentCheck();			// Rgǂ𔻒肷
	int  IncludeFileOn();			// CN[ht@C       (ĉAŎgp)
	char *GetIncludeFileName();		// CN[ht@C擾   (ĉAŎgp)
	void IncludeFileClear();		// CN[ht@C (ĉAŎgp)
	void GateIO_FileEndCheck();		//
	COMMENT_CNT LocalStep;			// 
	//-------------------------------------------------------------
	char *GetFuncHeaderInfo();		// ֐wb_[擾
	void FuncHeaderInfoReadOnOff(int);	// ֐wb_[̓ǂݍ݂s^~
	void ThisLineIsNotFuncHeader();		// ̍sɃRgƂĂ֐wb_[ɉȂB
	//-------------------------------------------------------------
	void SetEpConfModeOn();			// Epconfig.datǂݍނƂɎgpʏ؂ւp
	int  GetConfMode();			// EPTREE̒`̓ǂݍ݂̃[h
	int  GetConfLang();			// ݒf[^̌(C,C++,JAVA)
	int  CheckEpConfLangu(char *);		// EP_C, EP_CPP, EP_CPP Ȃǂ#ifdefŋLqĂ邩
	void GateIO_SetInterruptKeyWord(std::vector<std::string> &);// 荞݊֐o^߂̃L[[h
	std::vector<std::string> &GateIO_GetInterruptKeyWord();	// 荞݊֐o^߂̃L[[h

protected:
	void GateIO_Shyokika();			//
	void GateIO_SrcChg();			// \[X̓ǂݍ݊Jn
	int  GetExternCflg();			// extern "C" 1ԂB܂tȌsB

private:
	void GateIO_Shyokika_sub();
	int  CommentEndCheck(char *);		// Rg̏I𒲂ׂ
	int  CommentEndCheck_C(char *);		// Rg̏I𒲂ׂ
	int  CommentEndCheck_VB(char *);	// Rg̏I𒲂ׂ
	int  CommentEndCheck_Delphi(char *);	// Rg̏I𒲂ׂ
	int  CommentBeginCheck(char *);		// Rg̊Jn𒲂ׂ
	int  CommentBeginCheck_C(char *);	// Rg̊Jn𒲂ׂ
	int  CommentBeginCheck_VB(char *);	// Rg̊Jn𒲂ׂ
	int  CommentBeginCheck_Delphi(char *);	// Rg̊Jn𒲂ׂ
	void Bunseki_C(char *);			// #e𕪐
	void Bunseki_VB(char *);		// #e𕪐
	void Bunseki_Delphi(char *);		// #e𕪐
	int  IfEndCheck(char *);		// #if,#ifdef̏I`FbN
	int  IfEndCheck_C(char *);		// #if,#ifdef̏I`FbN
	int  IfEndCheck_VB(char *);		// #if,#ifdef̏I`FbN
	int  IfEndCheck_Delphi(char *);		// #if,#ifdef̏I`FbN
	//-------------------------------------------------------------
	int  Includefile;			//
	int  NextCM;				// #ỏ͗pXe[^X
	int  comment;				// RgXe[^X
	int  comment_ending_stat;		// RgԏI
	int  ifdefcheck;			// ݂̕L̃`FbN
	int  Mukounaifdef;			// #ifdefɂ薳ꂽꏊɂ#ifdef (#if܂)
	int  includeKind;			// 0:[U[CN[h  1:WCN[h
	int  step_line_ck;			// s`FbN
	int  comm_line_ck;			// Rgs`FbN
	int  shrp_line_ck;			// #s`FbN
	int  ififdef_step_ck;			// ꂽs`FbN
	int  ExternCflg;			// 
	int  InlineAsm;				// CCAZu͒tO
	//-------------------------------------------------------------
	int  BaseFlg;				// {NXȂ1
	int  HeaderHyojiFlg;			// wb_[ǂݍސݒɂȂĂ邩ǂ
	int  FuncHeaderReadFlg;			// ֐̃wb_[̕ۑ邩ǂ̃tO
	std::string m_strFuncHeader;		// ֐̃wb_[̃Rgۑ
	int  FuncHeaderNotComment;		// ̍sɃRgƂĂ֐wb_[ɉȂB
	//-------------------------------------------------------------
	int  EpConfMode;			// EPTREE̒`̓ǂݍ݂̃[h
	int  EpConfLangu;			// ݒf[^̌(C,C++,JAVA,VB,Delphi)
	int  EpConfLanguFound;			// ݒf[^̌w肪ĂKw
	int  EpConfigModeOn;			// Epconfig.datǂݍނƂɎgpʏ؂ւp
	//-------------------------------------------------------------
	int  StringCode;			// R[h
	int  SettingReadBuf_flg;		// 
	char PushP;
	int  LoopPush;
	int  KaigyouFlg;			// '_'ꍇ͉s
	KihonData *SetReadBuf;			// t@C̓ǂݏoɒPۑobt@
	std::string m_strIfelifData;		// #if,#elif̕ۑ ()
	std::string m_strIncFileName;		// t@Cۑ (wb_[t@C)
	std::vector<std::string> m_vecWariKeyWord;	// 荞݃L[[h
	std::vector<IF_OR_IFDEF> vecifdef;	//
};


#endif	//////////////////////////////////////

